
.proc InitPlayer
  lda #0
  sta PlayerPXL,x
  sta PlayerPYL,x
  sta PlayerAngle,x
  sta PlayerShootAngle,x
  sta PlayerSpeedBurst,x
  sta PlayerSpeedBurstRate,x
  sta PlayerInvincible,x
  sta PlayerHoldR,x
  sta PlayerSpeedupTimer,x
  sta PlayerBumpSoundTimer,x
  lda #2
  sta PlayerSpeed,x
  lda #15
  sta PlayerAmmo,x
  lda #25
  sta PlayerHealth,x
  rts
.endproc

NewGameHard:
  inc DifficultyMode
NewGame:
  lda retraces
  bne :+
    lda #1
: sta r_seed
.proc NewLevel
  jsr wait_vblank
  lda LevelMapNumber
  cmp #10
  jeq StartMainMenu

  lda #0
  sta PPUMASK

.if 0
  lda #8
  sta LevelSpinShootSpeed
  lda #%111
  sta LevelSpinShootChance
  sta LevelSpinShootRate
.endif

  lda EditMode
  bne :+
  lda LevelMapNumber
  jsr DecodeLevelData
: jsr RenderLevelBuf

  jsr wait_vblank
  lda #OBJ_ON + BG_ON
  sta PPUMASK

  ldx #0
  jsr InitPlayer

  lda #10*8
  sta PlayerPXH
  lda #7*8
  sta PlayerPYH

  lda #1
  sta PlayerEnabled
  lda #20
  sta EnemiesLeftForNextLevel

  lda #0
  tax
: sta BulletF,x
  inx
  cpx #BulletLen*10
  bne :-

  jsr init_sound
  lda #0
  jsr init_music

  lda #4
  sta MaxScreenEnemies

  lda #-1
  sta NeedSound

  ldx #AObjectLen
  lda #0
: sta AObjectF1,x
  dex
  bpl :-

  ldx #0
  txa
: sta DelayedMetaEditType,x
  inx
  cpx #MaxDelayedMetaEdits
  bne :-

  jmp MainLoop
.endproc
